## ufo-filters 0.17.0.76.g691aa0e%2Bdfsg1

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ufo-filters.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ufo-filters.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/ufo-filters"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ufo-filters"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
ufo-filters (0.17.0.76.g691aa0e+dfsg1-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 11 Jul 2025 16:57:59 +0200

ufo-filters (0.17.0.76.g691aa0e+dfsg1-2) unstable; urgency=medium

  * d/t/no-ocl: Upgraded test of task introspection
  * Bug fix: "Transpose task missing properties", thanks to Stuart Read
    (Closes: #1108226).
  * Bug fix: "Fails to build source after successful build", thanks to
    Lucas Nussbaum (Closes: #1048701).

 -- Serge Cohen <serge1cohen@free.fr>  Mon, 30 Jun 2025 13:41:19 +0200

ufo-filters (0.17.0.76.g691aa0e+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.17.0.76.g691aa0e+dfsg1

 -- Serge Cohen <serge.cohen@cnrs.fr>  Tue, 20 May 2025 02:51:22 +0200

## ufo-filters 0.17.0.76.g691aa0e+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if (POLICY CMP0018)
cmake_policy(SET CMP0018 OLD)
endif ()

if (POLICY CMP0046)
cmake_policy(SET CMP0046 OLD)
endif ()

if (POLICY CMP0053)
cmake_policy(SET CMP0053 OLD)
endif ()

if (POLICY CMP0054)
cmake_policy(SET CMP0054 OLD)
endif ()

project(ufo C CXX)

set(TARNAME "ufo-filters")

set(UFO_FILTERS_VERSION_MAJOR "0")
set(UFO_FILTERS_VERSION_MINOR "17")
set(UFO_FILTERS_VERSION_PATCH "0")
set(UFO_FILTERS_VERSION_STRING_LONG "${UFO_FILTERS_VERSION_MAJOR}.${UFO_FILTERS_VERSION_MINOR}.${UFO_FILTERS_VERSION_PATCH}")
set(UFO_FILTERS_VERSION_STRING_SHORT "${UFO_FILTERS_VERSION_MAJOR}.${UFO_FILTERS_VERSION_MINOR}")

set(UFO_DESCRIPTION "UFO good filters")
set(UFO_DESCRIPTION_SUMMARY "UFO good filters")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/common/cmake")

if (APPLE)
    set(CMAKE_MACOSX_RPATH      "ON")
    set(CMAKE_INSTALL_RPATH     "${CMAKE_INSTALL_PREFIX}/lib")
endif()

#{{{ Variables and Options
include(GNUInstallDirs)
include(PkgConfigVars)

set(PKG_UFO_CORE_MIN_REQUIRED "0.16")
# Backprojection burst mode, must be one of 1, 2, 4, 8, 16
set(BP_BURST "16" CACHE STRING "Number of projections processed in one pass")

option(WITH_PROFILING "Enable profiling" OFF)

if (WITH_PROFILING)
    add_definitions("-pg")
    set(CMAKE_C_FLAGS "-pg")
endif ()

option(WITH_CONTRIB "Enable contrib filters" OFF)
#}}}
#{{{ Common dependencies
find_package(OpenCL REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(UFO ufo>=${PKG_UFO_CORE_MIN_REQUIRED} REQUIRED)

pkg_check_variable(ufo plugindir)
pkg_check_variable(ufo kerneldir)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/deps/oclfft)

link_directories(${UFO_LIBRARY_DIRS})
#}}}
#{{{ Global definitions
add_definitions("-Wall -Wextra -fPIC")
add_definitions(-DG_LOG_DOMAIN="Ufo")

if (CMAKE_COMPILER_IS_GNUCC OR ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang"))
    add_definitions("-Wno-unused-parameter")
endif ()
#}}}
#{{{ Subdirectories
enable_testing()

add_subdirectory(docs)
add_subdirectory(deps)
add_subdirectory(src)
add_subdirectory(tests)
if (WITH_CONTRIB)
    add_subdirectory(contrib)
endif ()
#}}}

=== contrib/CMakeLists.txt ===
##
## This file is part of ufo-serge filter set.
## Copyright (C) 2016 Serge Cohen
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.
##
## Serge Cohen <serge.cohen@synchrotron-soleil.fr>
##

set(contrib_sxc_filter_SRCS
   ufo-backproject-irregular-task.c
   ufo-bin-voxels-task.c
   ufo-destrip-faster-task.c
   ufo-destrip-sinogram-task.c
   ufo-med-mad-reject-2d-task.c
   ufo-med-mad-reject-task.c
   ufo-ocl-1liner-task.c
   ufo-rotate-reframe-task.c
   ufo-smooth-pad-task.c
   ufo-stat-monitor-task.c
   )

set(contrib_sxc_aux_SRCS
    ufo-sxc-common.c)

file(GLOB contrib_sxc_filter_KERNELS "kernels/*.cl")

include(ConfigurePaths)
include(PkgConfigVars)
include(CheckCSourceCompiles)

configure_paths(CONTRIB_SXC_FILTERS)

find_package(OpenCL REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(UFO ufo>=${PKG_UFO_CORE_MIN_REQUIRED} REQUIRED)
pkg_check_variable(ufo plugindir)
pkg_check_variable(ufo kerneldir)

add_definitions("-std=c99 -Wall -fPIC")
add_definitions(-DG_LOG_DOMAIN="Ufo")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${OPENCL_INCLUDE_DIRS}
                    ${UFO_INCLUDE_DIRS})

link_directories(${UFO_LIBRARY_DIRS} ${OPENCL_LIBRARY_DIRS})

set(CMAKE_REQUIRED_INCLUDES ${OPENCL_INCLUDE_DIRS})

set(ufofilter_LIBS
    m
    ${UFO_LIBRARIES}
    ${OpenCL_LIBRARIES})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -pedantic -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")
set(CL_TARGET_OPENCL_VERSION "120")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# build static auxiliary library first
add_library(contrib_sxc_aux STATIC ${contrib_sxc_aux_SRCS})

foreach(_src ${contrib_sxc_filter_SRCS})
    # find plugin suffix
    string(REGEX REPLACE "ufo-([^ \\.]+)-task.*" "\\1" task "${_src}")

    # build string to get auxalleanous sources
    string(REPLACE "-" "_" _aux ${task})
    string(TOUPPER ${_aux} _aux_upper)

    # build string to get miscalleanous sources
    string(REPLACE "-" "_" _misc ${task})

    # create an option name and add this to disable filters
    set(_aux_src "${_aux}_aux_SRCS")
    set(_aux_libs "${_aux}_aux_LIBS")

    set(target "ufofilter${task}")

    # build single shared library per filter
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        add_library(${target} MODULE ${_src} ${${_aux_src}})
    else()
        add_library(${target} SHARED ${_src} ${${_aux_src}})
    endif()

    target_link_libraries(${target} ${ufofilter_LIBS} ${${_aux_libs}} contrib_sxc_aux)

    list(APPEND all_targets ${target})

    install(TARGETS ${target}
            ARCHIVE DESTINATION ${UFO_PLUGINDIR}
            LIBRARY DESTINATION ${UFO_PLUGINDIR})
endforeach()


# copy kernels
foreach(_kernel ${contrib_sxc_filter_KERNELS})
    install(FILES ${_kernel} DESTINATION ${UFO_KERNELDIR})
endforeach()

=== deps/CMakeLists.txt ===
option(WITH_OCLFFT "Build and distribute Apple FFT" ON)

if (WITH_OCLFFT)
    add_subdirectory(oclfft)
endif ()

=== docs/requirements.txt ===
docutils==0.17.1
jinja2==3.1.2
sphinx==5.0.2
sphinx-rtd-theme==1.0.0
sphinxcontrib-bibtex

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#{{{ Sources
set(ufofilter_SRCS
    ufo-average-task.c
    ufo-backproject-task.c
    ufo-bin-task.c
    ufo-binarize-task.c
    ufo-blur-task.c
    ufo-buffer-task.c
    ufo-calculate-task.c
    ufo-clip-task.c
    ufo-crop-task.c
    ufo-cross-correlate-task.c
    ufo-cut-task.c
    ufo-cut-sinogram-task.c
    ufo-center-of-rotation-task.c
    ufo-concatenate-result-task.c
    ufo-cone-beam-projection-weight-task.c
    ufo-contrast-task.c
    ufo-correlate-stacks-task.c
    ufo-dfi-sinc-task.c
    ufo-denoise-task.c
    ufo-detect-edge-task.c
    ufo-rescale-task.c
    ufo-dummy-data-task.c
    ufo-dump-ring-task.c
    ufo-duplicate-task.c
    ufo-filter-task.c
    ufo-find-large-spots-task.c
    ufo-flatten-task.c
    ufo-flatten-inplace-task.c
    ufo-flat-field-correct-task.c
    ufo-fft-task.c
    ufo-fftmult-task.c
    ufo-filter-particle-task.c
    ufo-filter-stripes-task.c
    ufo-filter-stripes1d-task.c
    ufo-flip-task.c
    ufo-forwardproject-task.c
    ufo-get-dup-circ-task.c
    ufo-gradient-task.c
    ufo-general-backproject-task.c
    ufo-horizontal-interpolate-task.c
    ufo-ifft-task.c
    ufo-interpolate-task.c
    ufo-interpolate-stream-task.c
    ufo-lamino-backproject-task.c
    ufo-loop-task.c
    ufo-map-color-task.c
    ufo-map-slice-task.c
    ufo-mask-task.c
    ufo-measure-task.c
    ufo-measure-sharpness-task.c
    ufo-median-filter-task.c
    ufo-memory-in-task.c
    ufo-memory-out-task.c
    ufo-merge-task.c
    ufo-metaballs-task.c
    ufo-monitor-task.c
    ufo-non-local-means-task.c
    ufo-null-task.c
    ufo-opencl-task.c
    ufo-opencl-reduce-task.c
    ufo-ordfilt-task.c
    ufo-pad-task.c
    ufo-polar-coordinates-task.c
    ufo-power-spectrum-task.c
    ufo-read-task.c
    ufo-reduce-task.c
    ufo-refeed-task.c
    ufo-remove-circle-task.c
    ufo-remove-outliers-task.c
    ufo-retrieve-phase-task.c
    ufo-ring-pattern-task.c
    ufo-ringwriter-task.c
    ufo-replicate-task.c
    ufo-rotate-task.c
    ufo-sleep-task.c
    ufo-slice-task.c
    ufo-sliding-stack-task.c
    ufo-stack-task.c
    ufo-stacked-backproject-task.c
    ufo-stdin-task.c
    ufo-stitch-task.c
    ufo-tile-task.c
    ufo-transpose-task.c
    ufo-transpose-projections-task.c
    ufo-swap-quadrants-task.c
    ufo-subtract-task.c
    ufo-volume-render-task.c
    ufo-write-task.c
    ufo-zeropad-task.c
    )

set(ufoaux_SRCS
    ufo-priv.c)

set(read_aux_SRCS
    readers/ufo-reader.c
    readers/ufo-edf-reader.c
    readers/ufo-raw-reader.c)

set(write_aux_SRCS
    writers/ufo-writer.c
    writers/ufo-raw-writer.c)

set(stdout_aux_SRCS
    writers/ufo-writer.c)

set(filter_aux_SRCS
    common/ufo-fft.c)

set(fft_aux_SRCS
    common/ufo-math.c
    common/ufo-fft.c)

set(ifft_aux_SRCS
    common/ufo-math.c
    common/ufo-fft.c)

set(retrieve_phase_aux_SRCS
    common/ufo-fft.c)

set(lamino_backproject_aux_SRCS
    lamino-roi.c)

set(cone_beam_projection_weight_aux_SRCS
    common/ufo-scarray.c)

set(general_backproject_aux_SRCS
    common/ufo-math.c
    common/ufo-conebeam.c
    common/ufo-scarray.c
    common/ufo-ctgeometry.c)

set(cross_correlate_aux_SRCS
    common/ufo-math.c
    common/ufo-fft.c)

set(non_local_means_aux_SRCS
    common/ufo-math.c
    common/ufo-common.c)

set(find_large_spots_aux_SRCS
    common/ufo-math.c
    common/ufo-common.c)

file(GLOB ufofilter_KERNELS "kernels/*.cl")
#}}}
#{{{ Variables
set(ufofilter_LIBS
    m
    ${UFO_LIBRARIES}
    ${OpenCL_LIBRARIES})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -pedantic -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")
set(CL_TARGET_OPENCL_VERSION "120")

add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGE_FILES)
#}}}
#{{{ Dependency checks
find_package(TIFF)
find_package(HDF5 1.8)
find_package(JPEG)
find_package(OpenMP)
find_package(OpenCV)

pkg_check_modules(UCA libuca>=1.2)
pkg_check_modules(LIBTIFF4 libtiff-4>=4.0.0)
pkg_check_modules(CLFFT clFFT)
pkg_check_modules(CLBLAST clblast)
pkg_check_modules(PANGOCAIRO pangocairo)
pkg_check_modules(OPENCV opencv)
pkg_check_modules(ZMQ libzmq)
pkg_check_modules(JSON_GLIB json-glib-1.0)


if (OPENMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
endif ()

if (OpenCL_VERSION_MAJOR)
    if (${OpenCL_VERSION_MAJOR} GREATER 1 OR
        (${OpenCL_VERSION_MAJOR} EQUAL 1 AND ${OpenCL_VERSION_MINOR} GREATER 1))
        # We need OpenCL > 1.1 for clEnqueueFillBuffer.
        list(APPEND ufofilter_SRCS ufo-segment-task.c)
    endif ()
endif ()

if (TIFF_FOUND)
    list(APPEND read_aux_SRCS readers/ufo-tiff-reader.c)
    list(APPEND read_aux_LIBS ${TIFF_LIBRARIES})
    list(APPEND write_aux_SRCS writers/ufo-tiff-writer.c)
    list(APPEND write_aux_LIBS ${TIFF_LIBRARIES})
    include_directories(${TIFF_INCLUDE_DIRS})
    link_directories(${TIFF_LIBRARY_DIRS})
    set(HAVE_TIFF True)
elseif (LIBTIFF4_INCLUDE_DIRS AND LIBTIFF4_LIBRARIES)
    list(APPEND read_aux_SRCS readers/ufo-tiff-reader.c)
    list(APPEND read_aux_LIBS ${LIBTIFF4_LIBRARIES})
    list(APPEND write_aux_SRCS writers/ufo-tiff-writer.c)
    list(APPEND write_aux_LIBS ${LIBTIFF4_LIBRARIES})
    include_directories(${LIBTIFF4_INCLUDE_DIRS})
    link_directories(${LIBTIFF4_LIBRARY_DIRS})
    set(HAVE_TIFF True)
endif ()

if (JPEG_FOUND)
    list(APPEND write_aux_SRCS writers/ufo-jpeg-writer.c)
    list(APPEND write_aux_LIBS ${JPEG_LIBRARIES})
    include_directories(${JPEG_INCLUDE_DIRS})
    link_directories(${JPEG_LIBRARY_DIRS})
    set(HAVE_JPEG True)
endif ()

if (HDF5_FOUND)
    option(WITH_HDF5 "Use HDF5" ON)
    if (WITH_HDF5)
        # This hack is proudly presented by stupid CMake configure scripts and a
        # badly written libhdf5.
        find_path(MPI_INCLUDE_PATH NAMES mpi.h PATHS /usr/include /usr/include/mpich2 /usr/lib/openmpi/include)

        if (MPI_INCLUDE_PATH)
            include_directories(${MPI_INCLUDE_PATH})
        endif ()

        list(APPEND read_aux_SRCS readers/ufo-hdf5-reader.c common/hdf5.c)
        list(APPEND read_aux_LIBS ${HDF5_LIBRARIES})
        list(APPEND write_aux_SRCS writers/ufo-hdf5-writer.c common/hdf5.c)
        list(APPEND write_aux_LIBS ${HDF5_LIBRARIES})
        include_directories(${HDF5_INCLUDE_DIRS})
        link_directories(${HDF5_LIBRARY_DIRS})
    endif ()
endif ()

if (UCA_INCLUDE_DIRS AND UCA_LIBRARIES)
    list(APPEND ufofilter_SRCS ufo-camera-task.c)
    list(APPEND camera_aux_LIBS ${UCA_LIBRARIES})
    include_directories(${UCA_INCLUDE_DIRS})
    link_directories(${UCA_LIBRARY_DIRS})
endif ()

if (TARGET oclfft)
    option(WITH_OCLFFT "Use Apple FFT" ON)

    if (WITH_OCLFFT)
        list(APPEND fft_aux_LIBS oclfft)
        list(APPEND ifft_aux_LIBS oclfft)
        list(APPEND retrieve_phase_aux_LIBS oclfft)
        list(APPEND filter_aux_LIBS oclfft)
        list(APPEND cross_correlate_aux_LIBS oclfft)
        set(HAVE_AMD OFF)
    endif ()
endif ()

if (CLFFT_FOUND)
    option(WITH_CLFFT "Use AMD clFFT" ON)

    if (WITH_CLFFT)
        include_directories(${CLFFT_INCLUDE_DIRS})
        list(APPEND fft_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND ifft_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND retrieve_phase_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND filter_aux_LIBS ${CLFFT_LIBRARIES})
        list(APPEND cross_correlate_aux_LIBS ${CLFFT_LIBRARIES})
        set(HAVE_AMD ON)
    endif ()
endif ()

if (CLBLAST_FOUND)
    include_directories(${CLBLAST_INCLUDE_DIRS})
    list(APPEND ufofilter_SRCS ufo-gemm-task.c)
    list(APPEND gemm_aux_LIBS ${CLBLAST_LIBRARIES})
endif ()

if (PANGOCAIRO_FOUND)
    include_directories(${PANGOCAIRO_INCLUDE_DIRS})
    list(APPEND ufofilter_SRCS ufo-stamp-task.c)
    list(APPEND stamp_aux_LIBS ${PANGOCAIRO_LIBRARIES})
endif ()

if (OpenCV_FOUND)
    include_directories(${OpenCV_INCLUDE_DIRS})
    list(APPEND ufofilter_SRCS ufo-cv-show-task.cpp)
    list(APPEND cv_show_aux_LIBS ${OpenCV_LIBRARIES})
    list(APPEND cv_show_aux_SRCS writers/ufo-writer.c)
elseif (OPENCV_FOUND)
    include_directories(${OPENCV_INCLUDE_DIRS})
    list(APPEND ufofilter_SRCS ufo-cv-show-task.cpp)
    list(APPEND cv_show_aux_LIBS ${OPENCV_LIBRARIES})
    list(APPEND cv_show_aux_SRCS writers/ufo-writer.c)
endif ()

if (ZMQ_FOUND AND JSON_GLIB_FOUND)
    include_directories(${ZMQ_INCLUDE_DIRS} ${JSON_GLIB_INCLUDE_DIRS})
    link_directories(${ZMQ_LIBRARY_DIRS} ${JSON_GLIB_LIBRARY_DIRS})
    list(APPEND ufofilter_SRCS ufo-zmq-pub-task.c ufo-zmq-sub-task.c)
    list(APPEND zmq_sub_aux_LIBS ${ZMQ_LIBRARIES} ${JSON_GLIB_LIBRARIES})
    list(APPEND zmq_pub_aux_LIBS ${ZMQ_LIBRARIES} ${JSON_GLIB_LIBRARIES})
    list(APPEND zmq_sub_aux_LIBS ${ZMQ_LIBRARIES} ${JSON_GLIB_LIBRARIES})
endif ()
#}}}
#{{{ Plugin targets
include_directories(${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${OpenCL_INCLUDE_DIRS}
                    ${UFO_INCLUDE_DIRS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# build static auxiliary library first
add_library(ufoaux STATIC ${ufoaux_SRCS})

foreach(_src ${ufofilter_SRCS})
    # find plugin suffix
    string(REGEX REPLACE "ufo-([^ \\.]+)-task.*" "\\1" task "${_src}")

    # build string to get auxalleanous sources
    string(REPLACE "-" "_" _aux ${task})
    string(TOUPPER ${_aux} _aux_upper)

    # create an option name and add this to disable filters
    set(_aux_src "${_aux}_aux_SRCS")
    set(_aux_libs "${_aux}_aux_LIBS")

    set(target "ufofilter${task}")

    # build single shared library per filter
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        add_library(${target} MODULE ${_src} ${${_aux_src}})
    else()
        add_library(${target} SHARED ${_src} ${${_aux_src}})
    endif()

    target_link_libraries(${target} ${ufofilter_LIBS} ${${_aux_libs}} ufoaux)

    list(APPEND all_targets ${target})

    install(TARGETS ${target}
            ARCHIVE DESTINATION ${UFO_PLUGINDIR}
            LIBRARY DESTINATION ${UFO_PLUGINDIR})
endforeach()
#}}}
#{{{ Subdirectories
add_subdirectory(kernels)
#}}}

=== tests/CMakeLists.txt ===
find_program(BASH bash)
find_package(PythonInterp REQUIRED)

add_test(test_file_write_regression
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-file-write-regression.sh")

add_test(test_142
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-142.sh")

add_test(test_149
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-149.sh")

add_test(test_153
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-153.sh")

add_test(test_161
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-161.sh")

add_test(test_177
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-177.sh")

add_test(test_core_149
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-core-149.sh")

add_test(test_nlm
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-nlm.sh")

add_test(test_multipage_readers
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-multipage-readers.sh")

add_test(test_gradient
         ${BASH} "${CMAKE_CURRENT_SOURCE_DIR}/test-gradient.sh")

add_test(test_memin
         ${Python_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/test_memin.py")

add_test(test_fft
         ${Python_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/test_fft.py")

add_test(test_swap_quadrants
         ${Python_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/test_swap_quadrants.py")

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/make-input-multipage-readers
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tests)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/check-multipage-readers
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tests)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/check-gradient
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tests)

=== debian/control ===
Source: ufo-filters
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Serge Cohen <serge1cohen@free.fr>,
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-sphinxdoc <!nodoc>,
 cmake,
 libclfft-dev,
 libglib2.0-dev,
 libgsl0-dev | libgsl-dev,
 libhdf5-dev,
 libtiff-dev,
 libufo-dev (>= 0.16),
 ocl-icd-opencl-dev,
 python3,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-sphinxcontrib.bibtex,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/ufo-filters
Vcs-Git: https://salsa.debian.org/science-team/ufo-filters.git
Homepage: http://ufo.kit.edu/

Package: ufo-filters
Architecture: any
Multi-Arch: same
Depends:
 ufo-filters-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ufo-filters-doc,
Description: Set of plugins for ufo-core - runtime
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 This package contains 'average`, 'backproject-irregular`, 'backproject`,
 'bin-voxels`, 'bin`, 'binarize`, 'blur`, 'buffer`, 'calculate`,
 'center-of-rotation`, 'clip`, 'concatenate-result`,
 'cone-beam-projection-weight`, 'contrast`, 'correlate-stacks`, 'crop`,
 'cross-correlate`, 'cut-sinogram`, 'cut`, 'denoise`, 'destrip-faster`,
 'destrip-sinogram`, 'detect-edge`, 'dfi-sinc`, 'dummy-data`, 'dump-ring`,
 'duplicate`, 'fft`, 'fftmult`, 'filter-particle`, 'filter-stripes`,
 'filter-stripes1d`, 'filter`, 'find-large-spots`, 'flat-field-correct`,
 'flatten-inplace`, 'flatten`, 'flip`, 'forwardproject`, 'general-backproject`,
 'get-dup-circ`, 'gradient`, 'horizontal-interpolate`, 'ifft`,
 'interpolate-stream`, 'interpolate`, 'lamino-backproject`, 'loop`,
 'map-color`, 'map-slice`, 'mask`, 'measure-sharpness`, 'measure`,
 'med-mad-reject-2d`, 'med-mad-reject`, 'median-filter`, 'memory-in`,
 'memory-out`, 'merge`, 'metaballs`, 'monitor`, 'non-local-means`, 'null`,
 'ocl-1liner`, 'opencl-reduce`, 'opencl`, 'ordfilt`, 'pad`,
 'polar-coordinates`, 'power-spectrum`, 'read`, 'reduce`, 'refeed`,
 'remove-circle`, 'remove-outliers`, 'replicate`, 'rescale`,
 'retrieve-phase`, 'ring-pattern`, 'ringwriter`, 'rotate-reframe`,
 'rotate`, 'segment`, 'sleep`, 'slice`, 'sliding-stack`, 'smooth-pad`,
 'stack`, 'stacked-backproject`, 'stat-monitor`, 'stdin`, 'stitch`,
 'subtract`, 'swap-quadrants`, 'tile`, 'transpose-projections`,
 'transpose`, 'volume-render`, 'write`, 'zeropad`, 'zmq-pub`,
 'zmq-sub` plugins/tasks

Package: ufo-filters-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: Library for high-performance, GPU-based computing - documentation
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 This package provides the documentation for the plugins

Package: ufo-filters-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Library for high-performance, GPU-based computing - data
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 This package provides the OpenCL kernel files for the plugins

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_OCLFFT=OFF -DWITH_CONTRIB=ON

%:
	dh $@

override_dh_install:
	# ufo-filters
	dh_install -p ufo-filters usr/lib/*/ufo

	# ufo-filters-data
	dh_install -p ufo-filters-data usr/share/ufo

	# ufo-filters-doc
	dh_link -p ufo-filters-doc /usr/share/javascript/mathjax/MathJax.js /usr/share/doc/ufo-filters/html/_static/MathJax.js
	dh_install -p ufo-filters-doc obj-*/docs/manual/html usr/share/doc/ufo-filters/

override_dh_auto_test:

override_dh_missing:
	dh_missing --list-missing

=== debian/tests/control ===
Tests: reconstruct
Depends: ufo-filters, libufo-bin, git, pocl-opencl-icd, ca-certificates
Architecture: amd64, arm64, armel, armhf, i386
Restrictions: allow-stderr, needs-internet, skip-not-installable

Tests: no-ocl
Depends: ufo-filters, libufo-bin
Restrictions: allow-stderr, skip-not-installable
